/* this file is created by mksrc.rb (99/08/04 numa@ees.hokudai.ac.jp) */

#include <ruby.h>
#include <math.h>

struct MC_ARRAY {
    int type;        /* 0: int, 1: float */ 
    int dimension;   /* numbwer of dimension */
    int *size;       /* array size for each dimension */
    int total;       /* total size */
    union {
      int    *i;  /* body of the array; expressed as one-dimensitonal array */
      float  *f;  /* body of the array; expressed as one-dimensitonal array */
      double *d;  /* body of the array; expressed as one-dimensitonal array */
    } ptr;
};

#define F77_SetMCA(x,vx) \
        struct MC_ARRAY* x = (struct MC_ARRAY*)DATA_PTR(vx)

#define F77_SetInt(x,vx) \
        int   x = FIXNUM_P(vx) ? FIX2INT(vx) : (int)RFLOAT(vx)->value

#define F77_SetFloat(x,vx) \
        float x = FIXNUM_P(vx) ? (float)FIX2INT(vx) : (float)RFLOAT(vx)->value

#define F77_SetDouble(x,vx) \
        double x = FIXNUM_P(vx) ? (double)FIX2INT(vx) : RFLOAT(vx)->value

#define F77_SetString(x,vx) \
        char * x = STR2CSTR(vx)

#define F77_SetLogic(x,vx) \
        int x = FIXNUM_P(vx) ? (int)FIX2INT(vx) : \
           TYPE(vx)==T_FALSE || TYPE(vx)==T_NIL ? 0 : 1

#define F77_SetIntArray(x,vx) \
        int   * x = ((struct FR_ARRAY*)DATA_PTR(vx))->ptr.i

#define F77_SetFloatArray(x,vx) \
        float * x = ((struct MC_ARRAY*)DATA_PTR(vx))->ptr.f

#define F77_SetDoubleArray(x,vx) \
        float * x = ((struct MC_ARRAY*)DATA_PTR(vx))->ptr.d


#define F77_GetInt(x,vx) \
	vx = INT2FIX(x)

#define F77_GetFloat(x,vx) \
        vx = rb_float_new(x)

#define F77_GetDouble(x,vx) \
        vx = rb_float_new(x)

#define F77_GetString(x,vx) \
        vx = rb_str_new(x,strlen(x))

#define F77_GetLogic(x,vx) \
        (x) ? Qtrue : Qfalse

#define F77_NewInt(x) \
	INT2FIX(x)

#define F77_NewChar(x) \
	rb_str_new(x,strlen(x))


static VALUE
dcl_csgi(self,Vic)
    VALUE self,Vic;
{
  F77_SetInt(ic,Vic);
  char ret;
  ret = csgi_(&ic);
  return F77_NewChar(ret);;
}

static VALUE
dcl_isgc(self,Vch)
    VALUE self,Vch;
{
  F77_SetString(ch,Vch);
  int ret;
  ret = isgc_(ch,strlen(ch));
  return F77_NewInt(ret);;
}

static VALUE
dcl_scplu(self,Vn,Vupx,Vupy,Vupz)
    VALUE self,Vn,Vupx,Vupy,Vupz;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetFloatArray(upz,Vupz);
  scplu_(&n,upx,upy,upz);
  return Qnil;
}

static VALUE
dcl_scplv(self,Vn,Vvpx,Vvpy,Vvpz)
    VALUE self,Vn,Vvpx,Vvpy,Vvpz;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetFloatArray(vpz,Vvpz);
  scplv_(&n,vpx,vpy,vpz);
  return Qnil;
}

static VALUE
dcl_scspli(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  scspli_(&index);
  return Qnil;
}

static VALUE
dcl_scqpli(self,Vindex)
    VALUE self,Vindex;
{
  int   index;
  scqpli_(&index);
  F77_GetInt(index,Vindex);
  return Qnil;
}

static VALUE
dcl_scplzu(self,Vn,Vupx,Vupy,Vupz,Vindex)
    VALUE self,Vn,Vupx,Vupy,Vupz,Vindex;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetFloatArray(upz,Vupz);
  F77_SetInt(index,Vindex);
  scplzu_(&n,upx,upy,upz,&index);
  return Qnil;
}

static VALUE
dcl_scplzv(self,Vn,Vvpx,Vvpy,Vvpz,Vindex)
    VALUE self,Vn,Vvpx,Vvpy,Vvpz,Vindex;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetFloatArray(vpz,Vvpz);
  F77_SetInt(index,Vindex);
  scplzv_(&n,vpx,vpy,vpz,&index);
  return Qnil;
}

static VALUE
dcl_scpmu(self,Vn,Vupx,Vupy,Vupz)
    VALUE self,Vn,Vupx,Vupy,Vupz;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetFloatArray(upz,Vupz);
  scpmu_(&n,upx,upy,upz);
  return Qnil;
}

static VALUE
dcl_scpmv(self,Vn,Vvpx,Vvpy,Vvpz)
    VALUE self,Vn,Vvpx,Vvpy,Vvpz;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetFloatArray(vpz,Vvpz);
  scpmv_(&n,vpx,vpy,vpz);
  return Qnil;
}

static VALUE
dcl_scspmt(self,Vitype)
    VALUE self,Vitype;
{
  F77_SetInt(itype,Vitype);
  scspmt_(&itype);
  return Qnil;
}

static VALUE
dcl_scqpmt(self,Vitype)
    VALUE self,Vitype;
{
  int   itype;
  scqpmt_(&itype);
  F77_GetInt(itype,Vitype);
  return Qnil;
}

static VALUE
dcl_scspmi(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  scspmi_(&index);
  return Qnil;
}

static VALUE
dcl_scqpmi(self,Vindex)
    VALUE self,Vindex;
{
  int   index;
  scqpmi_(&index);
  F77_GetInt(index,Vindex);
  return Qnil;
}

static VALUE
dcl_scspms(self,Vrsize)
    VALUE self,Vrsize;
{
  F77_SetFloat(rsize,Vrsize);
  scspms_(&rsize);
  return Qnil;
}

static VALUE
dcl_scqpms(self,Vrsize)
    VALUE self,Vrsize;
{
  float rsize;
  scqpms_(&rsize);
  F77_GetFloat(rsize,Vrsize);
  return Qnil;
}

static VALUE
dcl_scpmzu(self,Vn,Vupx,Vupy,Vupz,Vitype,Vindex,Vrsize)
    VALUE self,Vn,Vupx,Vupy,Vupz,Vitype,Vindex,Vrsize;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetFloatArray(upz,Vupz);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  F77_SetFloat(rsize,Vrsize);
  scpmzu_(&n,upx,upy,upz,&itype,&index,&rsize);
  return Qnil;
}

static VALUE
dcl_scpmzv(self,Vn,Vvpx,Vvpy,Vvpz,Vitype,Vindex,Vrsize)
    VALUE self,Vn,Vvpx,Vvpy,Vvpz,Vitype,Vindex,Vrsize;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetFloatArray(vpz,Vvpz);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  F77_SetFloat(rsize,Vrsize);
  scpmzv_(&n,vpx,vpy,vpz,&itype,&index,&rsize);
  return Qnil;
}

static VALUE
dcl_scseye(self,Vxeye3,Vyeye3,Vzeye3)
    VALUE self,Vxeye3,Vyeye3,Vzeye3;
{
  F77_SetFloat(xeye3,Vxeye3);
  F77_SetFloat(yeye3,Vyeye3);
  F77_SetFloat(zeye3,Vzeye3);
  scseye_(&xeye3,&yeye3,&zeye3);
  return Qnil;
}

static VALUE
dcl_scqeye(self,Vxeye3,Vyeye3,Vzeye3)
    VALUE self,Vxeye3,Vyeye3,Vzeye3;
{
  float xeye3;
  float yeye3;
  float zeye3;
  scqeye_(&xeye3,&yeye3,&zeye3);
  F77_GetFloat(xeye3,Vxeye3);
  F77_GetFloat(yeye3,Vyeye3);
  F77_GetFloat(zeye3,Vzeye3);
  return Qnil;
}

static VALUE
dcl_scslog(self,Vlxlog3,Vlylog3,Vlzlog3)
    VALUE self,Vlxlog3,Vlylog3,Vlzlog3;
{
  F77_SetLogic(lxlog3,Vlxlog3);
  F77_SetLogic(lylog3,Vlylog3);
  F77_SetLogic(lzlog3,Vlzlog3);
  scslog_(&lxlog3,&lylog3,&lzlog3);
  return Qnil;
}

static VALUE
dcl_scqlog(self,Vlxlog3,Vlylog3,Vlzlog3)
    VALUE self,Vlxlog3,Vlylog3,Vlzlog3;
{
  int    lxlog3;
  int    lylog3;
  int    lzlog3;
  scqlog_(&lxlog3,&lylog3,&lzlog3);
  F77_GetLogic(lxlog3,Vlxlog3);
  F77_GetLogic(lylog3,Vlylog3);
  F77_GetLogic(lzlog3,Vlzlog3);
  return Qnil;
}

static VALUE
dcl_scsobj(self,Vxobj3,Vyobj3,Vzobj3)
    VALUE self,Vxobj3,Vyobj3,Vzobj3;
{
  F77_SetFloat(xobj3,Vxobj3);
  F77_SetFloat(yobj3,Vyobj3);
  F77_SetFloat(zobj3,Vzobj3);
  scsobj_(&xobj3,&yobj3,&zobj3);
  return Qnil;
}

static VALUE
dcl_scqobj(self,Vxobj3,Vyobj3,Vzobj3)
    VALUE self,Vxobj3,Vyobj3,Vzobj3;
{
  float xobj3;
  float yobj3;
  float zobj3;
  scqobj_(&xobj3,&yobj3,&zobj3);
  F77_GetFloat(xobj3,Vxobj3);
  F77_GetFloat(yobj3,Vyobj3);
  F77_GetFloat(zobj3,Vzobj3);
  return Qnil;
}

static VALUE
dcl_scsorg(self,Vsimfac,Vvxorg3,Vvyorg3,Vvzorg3)
    VALUE self,Vsimfac,Vvxorg3,Vvyorg3,Vvzorg3;
{
  F77_SetFloat(simfac,Vsimfac);
  F77_SetFloat(vxorg3,Vvxorg3);
  F77_SetFloat(vyorg3,Vvyorg3);
  F77_SetFloat(vzorg3,Vvzorg3);
  scsorg_(&simfac,&vxorg3,&vyorg3,&vzorg3);
  return Qnil;
}

static VALUE
dcl_scqorg(self,Vsimfac,Vvxorg3,Vvyorg3,Vvzorg3)
    VALUE self,Vsimfac,Vvxorg3,Vvyorg3,Vvzorg3;
{
  float simfac;
  float vxorg3;
  float vyorg3;
  float vzorg3;
  scqorg_(&simfac,&vxorg3,&vyorg3,&vzorg3);
  F77_GetFloat(simfac,Vsimfac);
  F77_GetFloat(vxorg3,Vvxorg3);
  F77_GetFloat(vyorg3,Vvyorg3);
  F77_GetFloat(vzorg3,Vvzorg3);
  return Qnil;
}

static VALUE
dcl_scspln(self,Vixax,Viyax,Vsect)
    VALUE self,Vixax,Viyax,Vsect;
{
  F77_SetInt(ixax,Vixax);
  F77_SetInt(iyax,Viyax);
  F77_SetFloat(sect,Vsect);
  scspln_(&ixax,&iyax,&sect);
  return Qnil;
}

static VALUE
dcl_scqpln(self,Vixax,Viyax,Vsect)
    VALUE self,Vixax,Viyax,Vsect;
{
  int   ixax;
  int   iyax;
  float sect;
  scqpln_(&ixax,&iyax,&sect);
  F77_GetInt(ixax,Vixax);
  F77_GetInt(iyax,Viyax);
  F77_GetFloat(sect,Vsect);
  return Qnil;
}

static VALUE
dcl_scsprj(self)
    VALUE self;
{
  scsprj_();
  return Qnil;
}

static VALUE
dcl_scstrf(self)
    VALUE self;
{
  scstrf_();
  return Qnil;
}

static VALUE
dcl_scstrn(self,Vitr3)
    VALUE self,Vitr3;
{
  F77_SetInt(itr3,Vitr3);
  scstrn_(&itr3);
  return Qnil;
}

static VALUE
dcl_scqtrn(self,Vitr3)
    VALUE self,Vitr3;
{
  int   itr3;
  scqtrn_(&itr3);
  F77_GetInt(itr3,Vitr3);
  return Qnil;
}

static VALUE
dcl_scsvpt(self,Vvxmin,Vvxmax,Vvymin,Vvymax,Vvzmin,Vvzmax)
    VALUE self,Vvxmin,Vvxmax,Vvymin,Vvymax,Vvzmin,Vvzmax;
{
  F77_SetFloat(vxmin,Vvxmin);
  F77_SetFloat(vxmax,Vvxmax);
  F77_SetFloat(vymin,Vvymin);
  F77_SetFloat(vymax,Vvymax);
  F77_SetFloat(vzmin,Vvzmin);
  F77_SetFloat(vzmax,Vvzmax);
  scsvpt_(&vxmin,&vxmax,&vymin,&vymax,&vzmin,&vzmax);
  return Qnil;
}

static VALUE
dcl_scqvpt(self,Vvxmin,Vvxmax,Vvymin,Vvymax,Vvzmin,Vvzmax)
    VALUE self,Vvxmin,Vvxmax,Vvymin,Vvymax,Vvzmin,Vvzmax;
{
  float vxmin;
  float vxmax;
  float vymin;
  float vymax;
  float vzmin;
  float vzmax;
  scqvpt_(&vxmin,&vxmax,&vymin,&vymax,&vzmin,&vzmax);
  F77_GetFloat(vxmin,Vvxmin);
  F77_GetFloat(vxmax,Vvxmax);
  F77_GetFloat(vymin,Vvymin);
  F77_GetFloat(vymax,Vvymax);
  F77_GetFloat(vzmin,Vvzmin);
  F77_GetFloat(vzmax,Vvzmax);
  return Qnil;
}

static VALUE
dcl_scswnd(self,Vuxmin,Vuxmax,Vuymin,Vuymax,Vuzmin,Vuzmax)
    VALUE self,Vuxmin,Vuxmax,Vuymin,Vuymax,Vuzmin,Vuzmax;
{
  F77_SetFloat(uxmin,Vuxmin);
  F77_SetFloat(uxmax,Vuxmax);
  F77_SetFloat(uymin,Vuymin);
  F77_SetFloat(uymax,Vuymax);
  F77_SetFloat(uzmin,Vuzmin);
  F77_SetFloat(uzmax,Vuzmax);
  scswnd_(&uxmin,&uxmax,&uymin,&uymax,&uzmin,&uzmax);
  return Qnil;
}

static VALUE
dcl_scqwnd(self,Vuxmin,Vuxmax,Vuymin,Vuymax,Vuzmin,Vuzmax)
    VALUE self,Vuxmin,Vuxmax,Vuymin,Vuymax,Vuzmin,Vuzmax;
{
  float uxmin;
  float uxmax;
  float uymin;
  float uymax;
  float uzmin;
  float uzmax;
  scqwnd_(&uxmin,&uxmax,&uymin,&uymax,&uzmin,&uzmax);
  F77_GetFloat(uxmin,Vuxmin);
  F77_GetFloat(uxmax,Vuxmax);
  F77_GetFloat(uymin,Vuymin);
  F77_GetFloat(uymax,Vuymax);
  F77_GetFloat(uzmin,Vuzmin);
  F77_GetFloat(uzmax,Vuzmax);
  return Qnil;
}

static VALUE
dcl_sctnu(self,Vupx,Vupy,Vupz)
    VALUE self,Vupx,Vupy,Vupz;
{
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetFloatArray(upz,Vupz);
  sctnu_(upx,upy,upz);
  return Qnil;
}

static VALUE
dcl_sctnv(self,Vvpx,Vvpy,Vvpz)
    VALUE self,Vvpx,Vvpy,Vvpz;
{
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetFloatArray(vpz,Vvpz);
  sctnv_(vpx,vpy,vpz);
  return Qnil;
}

static VALUE
dcl_scstnp(self,Vitpat1,Vitpat2)
    VALUE self,Vitpat1,Vitpat2;
{
  F77_SetInt(itpat1,Vitpat1);
  F77_SetInt(itpat2,Vitpat2);
  scstnp_(&itpat1,&itpat2);
  return Qnil;
}

static VALUE
dcl_scqtnp(self,Vitpat1,Vitpat2)
    VALUE self,Vitpat1,Vitpat2;
{
  int   itpat1;
  int   itpat2;
  scqtnp_(&itpat1,&itpat2);
  F77_GetInt(itpat1,Vitpat1);
  F77_GetInt(itpat2,Vitpat2);
  return Qnil;
}

static VALUE
dcl_sctnzu(self,Vupx,Vupy,Vupz,Vitpat1,Vitpat2)
    VALUE self,Vupx,Vupy,Vupz,Vitpat1,Vitpat2;
{
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetFloatArray(upz,Vupz);
  F77_SetInt(itpat1,Vitpat1);
  F77_SetInt(itpat2,Vitpat2);
  sctnzu_(upx,upy,upz,&itpat1,&itpat2);
  return Qnil;
}

static VALUE
dcl_sctnzv(self,Vvpx,Vvpy,Vvpz,Vitpat1,Vitpat2)
    VALUE self,Vvpx,Vvpy,Vvpz,Vitpat1,Vitpat2;
{
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetFloatArray(vpz,Vvpz);
  F77_SetInt(itpat1,Vitpat1);
  F77_SetInt(itpat2,Vitpat2);
  sctnzv_(vpx,vpy,vpz,&itpat1,&itpat2);
  return Qnil;
}

static VALUE
dcl_isgtrc(self,Vctr)
    VALUE self,Vctr;
{
  F77_SetString(ctr,Vctr);
  int ret;
  ret = isgtrc_(ctr,strlen(ctr));
  return F77_NewInt(ret);;
}

static VALUE
dcl_sglau(self,Vux1,Vuy1,Vux2,Vuy2)
    VALUE self,Vux1,Vuy1,Vux2,Vuy2;
{
  F77_SetFloat(ux1,Vux1);
  F77_SetFloat(uy1,Vuy1);
  F77_SetFloat(ux2,Vux2);
  F77_SetFloat(uy2,Vuy2);
  sglau_(&ux1,&uy1,&ux2,&uy2);
  return Qnil;
}

static VALUE
dcl_sglav(self,Vvx1,Vvy1,Vvx2,Vvy2)
    VALUE self,Vvx1,Vvy1,Vvx2,Vvy2;
{
  F77_SetFloat(vx1,Vvx1);
  F77_SetFloat(vy1,Vvy1);
  F77_SetFloat(vx2,Vvx2);
  F77_SetFloat(vy2,Vvy2);
  sglav_(&vx1,&vy1,&vx2,&vy2);
  return Qnil;
}

static VALUE
dcl_sglar(self,Vrx1,Vry1,Vrx2,Vry2)
    VALUE self,Vrx1,Vry1,Vrx2,Vry2;
{
  F77_SetFloat(rx1,Vrx1);
  F77_SetFloat(ry1,Vry1);
  F77_SetFloat(rx2,Vrx2);
  F77_SetFloat(ry2,Vry2);
  sglar_(&rx1,&ry1,&rx2,&ry2);
  return Qnil;
}

static VALUE
dcl_sgslat(self,Vitype)
    VALUE self,Vitype;
{
  F77_SetInt(itype,Vitype);
  sgslat_(&itype);
  return Qnil;
}

static VALUE
dcl_sgqlat(self,Vitype)
    VALUE self,Vitype;
{
  int   itype;
  sgqlat_(&itype);
  F77_GetInt(itype,Vitype);
  return Qnil;
}

static VALUE
dcl_sgslai(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  sgslai_(&index);
  return Qnil;
}

static VALUE
dcl_sgqlai(self,Vindex)
    VALUE self,Vindex;
{
  int   index;
  sgqlai_(&index);
  F77_GetInt(index,Vindex);
  return Qnil;
}

static VALUE
dcl_sglazr(self,Vrx1,Vry1,Vrx2,Vry2,Vitype,Vindex)
    VALUE self,Vrx1,Vry1,Vrx2,Vry2,Vitype,Vindex;
{
  F77_SetFloat(rx1,Vrx1);
  F77_SetFloat(ry1,Vry1);
  F77_SetFloat(rx2,Vrx2);
  F77_SetFloat(ry2,Vry2);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  sglazr_(&rx1,&ry1,&rx2,&ry2,&itype,&index);
  return Qnil;
}

static VALUE
dcl_sglazu(self,Vux1,Vuy1,Vux2,Vuy2,Vitype,Vindex)
    VALUE self,Vux1,Vuy1,Vux2,Vuy2,Vitype,Vindex;
{
  F77_SetFloat(ux1,Vux1);
  F77_SetFloat(uy1,Vuy1);
  F77_SetFloat(ux2,Vux2);
  F77_SetFloat(uy2,Vuy2);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  sglazu_(&ux1,&uy1,&ux2,&uy2,&itype,&index);
  return Qnil;
}

static VALUE
dcl_sglazv(self,Vvx1,Vvy1,Vvx2,Vvy2,Vitype,Vindex)
    VALUE self,Vvx1,Vvy1,Vvx2,Vvy2,Vitype,Vindex;
{
  F77_SetFloat(vx1,Vvx1);
  F77_SetFloat(vy1,Vvy1);
  F77_SetFloat(vx2,Vvx2);
  F77_SetFloat(vy2,Vvy2);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  sglazv_(&vx1,&vy1,&vx2,&vy2,&itype,&index);
  return Qnil;
}

static VALUE
dcl_sglnu(self,Vux1,Vuy1,Vux2,Vuy2)
    VALUE self,Vux1,Vuy1,Vux2,Vuy2;
{
  F77_SetFloat(ux1,Vux1);
  F77_SetFloat(uy1,Vuy1);
  F77_SetFloat(ux2,Vux2);
  F77_SetFloat(uy2,Vuy2);
  sglnu_(&ux1,&uy1,&ux2,&uy2);
  return Qnil;
}

static VALUE
dcl_sglnv(self,Vvx1,Vvy1,Vvx2,Vvy2)
    VALUE self,Vvx1,Vvy1,Vvx2,Vvy2;
{
  F77_SetFloat(vx1,Vvx1);
  F77_SetFloat(vy1,Vvy1);
  F77_SetFloat(vx2,Vvx2);
  F77_SetFloat(vy2,Vvy2);
  sglnv_(&vx1,&vy1,&vx2,&vy2);
  return Qnil;
}

static VALUE
dcl_sglnr(self,Vrx1,Vry1,Vrx2,Vry2)
    VALUE self,Vrx1,Vry1,Vrx2,Vry2;
{
  F77_SetFloat(rx1,Vrx1);
  F77_SetFloat(ry1,Vry1);
  F77_SetFloat(rx2,Vrx2);
  F77_SetFloat(ry2,Vry2);
  sglnr_(&rx1,&ry1,&rx2,&ry2);
  return Qnil;
}

static VALUE
dcl_sgslni(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  sgslni_(&index);
  return Qnil;
}

static VALUE
dcl_sgqlni(self,Vindex)
    VALUE self,Vindex;
{
  int   index;
  sgqlni_(&index);
  F77_GetInt(index,Vindex);
  return Qnil;
}

static VALUE
dcl_sglnzr(self,Vrx1,Vry1,Vrx2,Vry2,Vindex)
    VALUE self,Vrx1,Vry1,Vrx2,Vry2,Vindex;
{
  F77_SetFloat(rx1,Vrx1);
  F77_SetFloat(ry1,Vry1);
  F77_SetFloat(rx2,Vrx2);
  F77_SetFloat(ry2,Vry2);
  F77_SetInt(index,Vindex);
  sglnzr_(&rx1,&ry1,&rx2,&ry2,&index);
  return Qnil;
}

static VALUE
dcl_sglnzu(self,Vux1,Vuy1,Vux2,Vuy2,Vindex)
    VALUE self,Vux1,Vuy1,Vux2,Vuy2,Vindex;
{
  F77_SetFloat(ux1,Vux1);
  F77_SetFloat(uy1,Vuy1);
  F77_SetFloat(ux2,Vux2);
  F77_SetFloat(uy2,Vuy2);
  F77_SetInt(index,Vindex);
  sglnzu_(&ux1,&uy1,&ux2,&uy2,&index);
  return Qnil;
}

static VALUE
dcl_sglnzv(self,Vvx1,Vvy1,Vvx2,Vvy2,Vindex)
    VALUE self,Vvx1,Vvy1,Vvx2,Vvy2,Vindex;
{
  F77_SetFloat(vx1,Vvx1);
  F77_SetFloat(vy1,Vvy1);
  F77_SetFloat(vx2,Vvx2);
  F77_SetFloat(vy2,Vvy2);
  F77_SetInt(index,Vindex);
  sglnzv_(&vx1,&vy1,&vx2,&vy2,&index);
  return Qnil;
}

static VALUE
dcl_sgopn(self,Viws)
    VALUE self,Viws;
{
  F77_SetInt(iws,Viws);
  sgopn_(&iws);
  return Qnil;
}

static VALUE
dcl_sginit(self)
    VALUE self;
{
  sginit_();
  return Qnil;
}

static VALUE
dcl_sgfrm(self)
    VALUE self;
{
  sgfrm_();
  return Qnil;
}

static VALUE
dcl_sgcls(self)
    VALUE self;
{
  sgcls_();
  return Qnil;
}

static VALUE
dcl_sgpget(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetInt(ipara,Vipara);
  sgpget_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgiget(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetInt(ipara,Vipara);
  sgiget_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgrget(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetFloat(ipara,Vipara);
  sgrget_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sglget(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetLogic(ipara,Vipara);
  sglget_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgpset(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetInt(ipara,Vipara);
  sgpset_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgiset(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetInt(ipara,Vipara);
  sgiset_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgrset(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetFloat(ipara,Vipara);
  sgrset_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sglset(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetLogic(ipara,Vipara);
  sglset_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgpstx(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetInt(ipara,Vipara);
  sgpstx_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgistx(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetInt(ipara,Vipara);
  sgistx_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgrstx(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetFloat(ipara,Vipara);
  sgrstx_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sglstx(self,Vcp,Vipara)
    VALUE self,Vcp,Vipara;
{
  F77_SetString(cp,Vcp);
  F77_SetLogic(ipara,Vipara);
  sglstx_(cp,&ipara,strlen(cp));
  return Qnil;
}

static VALUE
dcl_sgplu(self,Vn,Vupx,Vupy)
    VALUE self,Vn,Vupx,Vupy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  sgplu_(&n,upx,upy);
  return Qnil;
}

static VALUE
dcl_sgplv(self,Vn,Vvpx,Vvpy)
    VALUE self,Vn,Vvpx,Vvpy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  sgplv_(&n,vpx,vpy);
  return Qnil;
}

static VALUE
dcl_sgplr(self,Vn,Vrpx,Vrpy)
    VALUE self,Vn,Vrpx,Vrpy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(rpx,Vrpx);
  F77_SetFloatArray(rpy,Vrpy);
  sgplr_(&n,rpx,rpy);
  return Qnil;
}

static VALUE
dcl_sgsplt(self,Vitype)
    VALUE self,Vitype;
{
  F77_SetInt(itype,Vitype);
  sgsplt_(&itype);
  return Qnil;
}

static VALUE
dcl_sgqplt(self,Vitype)
    VALUE self,Vitype;
{
  int   itype;
  sgqplt_(&itype);
  F77_GetInt(itype,Vitype);
  return Qnil;
}

static VALUE
dcl_sgspli(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  sgspli_(&index);
  return Qnil;
}

static VALUE
dcl_sgqpli(self,Vindex)
    VALUE self,Vindex;
{
  int   index;
  sgqpli_(&index);
  F77_GetInt(index,Vindex);
  return Qnil;
}

static VALUE
dcl_sgplzr(self,Vn,Vrpx,Vrpy,Vitype,Vindex)
    VALUE self,Vn,Vrpx,Vrpy,Vitype,Vindex;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(rpx,Vrpx);
  F77_SetFloatArray(rpy,Vrpy);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  sgplzr_(&n,rpx,rpy,&itype,&index);
  return Qnil;
}

static VALUE
dcl_sgplzu(self,Vn,Vupx,Vupy,Vitype,Vindex)
    VALUE self,Vn,Vupx,Vupy,Vitype,Vindex;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  sgplzu_(&n,upx,upy,&itype,&index);
  return Qnil;
}

static VALUE
dcl_sgplzv(self,Vn,Vvpx,Vvpy,Vitype,Vindex)
    VALUE self,Vn,Vvpx,Vvpy,Vitype,Vindex;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  sgplzv_(&n,vpx,vpy,&itype,&index);
  return Qnil;
}

static VALUE
dcl_sgpmu(self,Vn,Vupx,Vupy)
    VALUE self,Vn,Vupx,Vupy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  sgpmu_(&n,upx,upy);
  return Qnil;
}

static VALUE
dcl_sgpmv(self,Vn,Vvpx,Vvpy)
    VALUE self,Vn,Vvpx,Vvpy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  sgpmv_(&n,vpx,vpy);
  return Qnil;
}

static VALUE
dcl_sgpmr(self,Vn,Vrpx,Vrpy)
    VALUE self,Vn,Vrpx,Vrpy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(rpx,Vrpx);
  F77_SetFloatArray(rpy,Vrpy);
  sgpmr_(&n,rpx,rpy);
  return Qnil;
}

static VALUE
dcl_sgspmt(self,Vitype)
    VALUE self,Vitype;
{
  F77_SetInt(itype,Vitype);
  sgspmt_(&itype);
  return Qnil;
}

static VALUE
dcl_sgqpmt(self,Vitype)
    VALUE self,Vitype;
{
  int   itype;
  sgqpmt_(&itype);
  F77_GetInt(itype,Vitype);
  return Qnil;
}

static VALUE
dcl_sgspmi(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  sgspmi_(&index);
  return Qnil;
}

static VALUE
dcl_sgqpmi(self,Vindex)
    VALUE self,Vindex;
{
  int   index;
  sgqpmi_(&index);
  F77_GetInt(index,Vindex);
  return Qnil;
}

static VALUE
dcl_sgspms(self,Vrsize)
    VALUE self,Vrsize;
{
  F77_SetFloat(rsize,Vrsize);
  sgspms_(&rsize);
  return Qnil;
}

static VALUE
dcl_sgqpms(self,Vrsize)
    VALUE self,Vrsize;
{
  float rsize;
  sgqpms_(&rsize);
  F77_GetFloat(rsize,Vrsize);
  return Qnil;
}

static VALUE
dcl_sgpmzr(self,Vn,Vrpx,Vrpy,Vitype,Vindex,Vrsize)
    VALUE self,Vn,Vrpx,Vrpy,Vitype,Vindex,Vrsize;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(rpx,Vrpx);
  F77_SetFloatArray(rpy,Vrpy);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  F77_SetFloat(rsize,Vrsize);
  sgpmzr_(&n,rpx,rpy,&itype,&index,&rsize);
  return Qnil;
}

static VALUE
dcl_sgpmzu(self,Vn,Vupx,Vupy,Vitype,Vindex,Vrsize)
    VALUE self,Vn,Vupx,Vupy,Vitype,Vindex,Vrsize;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  F77_SetFloat(rsize,Vrsize);
  sgpmzu_(&n,upx,upy,&itype,&index,&rsize);
  return Qnil;
}

static VALUE
dcl_sgpmzv(self,Vn,Vvpx,Vvpy,Vitype,Vindex,Vrsize)
    VALUE self,Vn,Vvpx,Vvpy,Vitype,Vindex,Vrsize;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetInt(itype,Vitype);
  F77_SetInt(index,Vindex);
  F77_SetFloat(rsize,Vrsize);
  sgpmzv_(&n,vpx,vpy,&itype,&index,&rsize);
  return Qnil;
}

static VALUE
dcl_sgpqnp(self,Vncp)
    VALUE self,Vncp;
{
  int   ncp;
  sgpqnp_(&ncp);
  F77_GetInt(ncp,Vncp);
  return Qnil;
}

static VALUE
dcl_sgpqid(self,Vcp,Vidx)
    VALUE self,Vcp,Vidx;
{
  F77_SetString(cp,Vcp);
  int   idx;
  sgpqid_(cp,&idx,strlen(cp));
  F77_GetInt(idx,Vidx);
  return Qnil;
}

static VALUE
dcl_sgpqcp(self,Vidx,Vcp)
    VALUE self,Vidx,Vcp;
{
  F77_SetInt(idx,Vidx);
  char * cp="                ";
  sgpqcp_(&idx,cp,strlen(cp));
  F77_GetString(cp,Vcp);
  return Qnil;
}

static VALUE
dcl_sgpqvl(self,Vidx,Vipara)
    VALUE self,Vidx,Vipara;
{
  F77_SetInt(idx,Vidx);
  int   ipara;
  sgpqvl_(&idx,&ipara);
  F77_GetInt(ipara,Vipara);
  return Qnil;
}

static VALUE
dcl_sgpsvl(self,Vidx,Vipara)
    VALUE self,Vidx,Vipara;
{
  F77_SetInt(idx,Vidx);
  F77_SetInt(ipara,Vipara);
  sgpsvl_(&idx,&ipara);
  return Qnil;
}

static VALUE
dcl_sgpwsn(self)
    VALUE self;
{
  sgpwsn_();
  return Qnil;
}

static VALUE
dcl_sgsmpl(self,Vplx,Vply,Vplrot)
    VALUE self,Vplx,Vply,Vplrot;
{
  F77_SetFloat(plx,Vplx);
  F77_SetFloat(ply,Vply);
  F77_SetFloat(plrot,Vplrot);
  sgsmpl_(&plx,&ply,&plrot);
  return Qnil;
}

static VALUE
dcl_sgqmpl(self,Vplx,Vply,Vplrot)
    VALUE self,Vplx,Vply,Vplrot;
{
  float plx;
  float ply;
  float plrot;
  sgqmpl_(&plx,&ply,&plrot);
  F77_GetFloat(plx,Vplx);
  F77_GetFloat(ply,Vply);
  F77_GetFloat(plrot,Vplrot);
  return Qnil;
}

static VALUE
dcl_sgsplc(self,Vcharx)
    VALUE self,Vcharx;
{
  F77_SetString(charx,Vcharx);
  sgsplc_(charx,strlen(charx));
  return Qnil;
}

static VALUE
dcl_sgqplc(self,Vcharx)
    VALUE self,Vcharx;
{
  char * charx="                ";
  sgqplc_(charx,strlen(charx));
  F77_GetString(charx,Vcharx);
  return Qnil;
}

static VALUE
dcl_sgspls(self,Vrsize)
    VALUE self,Vrsize;
{
  F77_SetFloat(rsize,Vrsize);
  sgspls_(&rsize);
  return Qnil;
}

static VALUE
dcl_sgqpls(self,Vrsize)
    VALUE self,Vrsize;
{
  float rsize;
  sgqpls_(&rsize);
  F77_GetFloat(rsize,Vrsize);
  return Qnil;
}

static VALUE
dcl_sgnplc(self)
    VALUE self;
{
  sgnplc_();
  return Qnil;
}

static VALUE
dcl_sgssim(self,Vsimfac,Vvxoff,Vvyoff)
    VALUE self,Vsimfac,Vvxoff,Vvyoff;
{
  F77_SetFloat(simfac,Vsimfac);
  F77_SetFloat(vxoff,Vvxoff);
  F77_SetFloat(vyoff,Vvyoff);
  sgssim_(&simfac,&vxoff,&vyoff);
  return Qnil;
}

static VALUE
dcl_sgqsim(self,Vsimfac,Vvxoff,Vvyoff)
    VALUE self,Vsimfac,Vvxoff,Vvyoff;
{
  float simfac;
  float vxoff;
  float vyoff;
  sgqsim_(&simfac,&vxoff,&vyoff);
  F77_GetFloat(simfac,Vsimfac);
  F77_GetFloat(vxoff,Vvxoff);
  F77_GetFloat(vyoff,Vvyoff);
  return Qnil;
}

static VALUE
dcl_sgstrf(self)
    VALUE self;
{
  sgstrf_();
  return Qnil;
}

static VALUE
dcl_sgstrn(self,Vitr)
    VALUE self,Vitr;
{
  F77_SetInt(itr,Vitr);
  sgstrn_(&itr);
  return Qnil;
}

static VALUE
dcl_sgqtrn(self,Vitr)
    VALUE self,Vitr;
{
  int   itr;
  sgqtrn_(&itr);
  F77_GetInt(itr,Vitr);
  return Qnil;
}

static VALUE
dcl_sgstxy(self,Vtxmin,Vtxmax,Vtymin,Vtymax)
    VALUE self,Vtxmin,Vtxmax,Vtymin,Vtymax;
{
  F77_SetFloat(txmin,Vtxmin);
  F77_SetFloat(txmax,Vtxmax);
  F77_SetFloat(tymin,Vtymin);
  F77_SetFloat(tymax,Vtymax);
  sgstxy_(&txmin,&txmax,&tymin,&tymax);
  return Qnil;
}

static VALUE
dcl_sgqtxy(self,Vtxmin,Vtxmax,Vtymin,Vtymax)
    VALUE self,Vtxmin,Vtxmax,Vtymin,Vtymax;
{
  float txmin;
  float txmax;
  float tymin;
  float tymax;
  sgqtxy_(&txmin,&txmax,&tymin,&tymax);
  F77_GetFloat(txmin,Vtxmin);
  F77_GetFloat(txmax,Vtxmax);
  F77_GetFloat(tymin,Vtymin);
  F77_GetFloat(tymax,Vtymax);
  return Qnil;
}

static VALUE
dcl_sgsvpt(self,Vvxmin,Vvxmax,Vvymin,Vvymax)
    VALUE self,Vvxmin,Vvxmax,Vvymin,Vvymax;
{
  F77_SetFloat(vxmin,Vvxmin);
  F77_SetFloat(vxmax,Vvxmax);
  F77_SetFloat(vymin,Vvymin);
  F77_SetFloat(vymax,Vvymax);
  sgsvpt_(&vxmin,&vxmax,&vymin,&vymax);
  return Qnil;
}

static VALUE
dcl_sgqvpt(self,Vvxmin,Vvxmax,Vvymin,Vvymax)
    VALUE self,Vvxmin,Vvxmax,Vvymin,Vvymax;
{
  float vxmin;
  float vxmax;
  float vymin;
  float vymax;
  sgqvpt_(&vxmin,&vxmax,&vymin,&vymax);
  F77_GetFloat(vxmin,Vvxmin);
  F77_GetFloat(vxmax,Vvxmax);
  F77_GetFloat(vymin,Vvymin);
  F77_GetFloat(vymax,Vvymax);
  return Qnil;
}

static VALUE
dcl_sgswnd(self,Vuxmin,Vuxmax,Vuymin,Vuymax)
    VALUE self,Vuxmin,Vuxmax,Vuymin,Vuymax;
{
  F77_SetFloat(uxmin,Vuxmin);
  F77_SetFloat(uxmax,Vuxmax);
  F77_SetFloat(uymin,Vuymin);
  F77_SetFloat(uymax,Vuymax);
  sgswnd_(&uxmin,&uxmax,&uymin,&uymax);
  return Qnil;
}

static VALUE
dcl_sgqwnd(self,Vuxmin,Vuxmax,Vuymin,Vuymax)
    VALUE self,Vuxmin,Vuxmax,Vuymin,Vuymax;
{
  float uxmin;
  float uxmax;
  float uymin;
  float uymax;
  sgqwnd_(&uxmin,&uxmax,&uymin,&uymax);
  F77_GetFloat(uxmin,Vuxmin);
  F77_GetFloat(uxmax,Vuxmax);
  F77_GetFloat(uymin,Vuymin);
  F77_GetFloat(uymax,Vuymax);
  return Qnil;
}

static VALUE
dcl_sgtnu(self,Vn,Vupx,Vupy)
    VALUE self,Vn,Vupx,Vupy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  sgtnu_(&n,upx,upy);
  return Qnil;
}

static VALUE
dcl_sgtnv(self,Vn,Vvpx,Vvpy)
    VALUE self,Vn,Vvpx,Vvpy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  sgtnv_(&n,vpx,vpy);
  return Qnil;
}

static VALUE
dcl_sgtnr(self,Vn,Vrpx,Vrpy)
    VALUE self,Vn,Vrpx,Vrpy;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(rpx,Vrpx);
  F77_SetFloatArray(rpy,Vrpy);
  sgtnr_(&n,rpx,rpy);
  return Qnil;
}

static VALUE
dcl_sgstnp(self,Vitpat)
    VALUE self,Vitpat;
{
  F77_SetInt(itpat,Vitpat);
  sgstnp_(&itpat);
  return Qnil;
}

static VALUE
dcl_sgqtnp(self,Vitpat)
    VALUE self,Vitpat;
{
  int   itpat;
  sgqtnp_(&itpat);
  F77_GetInt(itpat,Vitpat);
  return Qnil;
}

static VALUE
dcl_sgtnzr(self,Vn,Vrpx,Vrpy,Vitpat)
    VALUE self,Vn,Vrpx,Vrpy,Vitpat;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(rpx,Vrpx);
  F77_SetFloatArray(rpy,Vrpy);
  F77_SetInt(itpat,Vitpat);
  sgtnzr_(&n,rpx,rpy,&itpat);
  return Qnil;
}

static VALUE
dcl_sgtnzu(self,Vn,Vupx,Vupy,Vitpat)
    VALUE self,Vn,Vupx,Vupy,Vitpat;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(upx,Vupx);
  F77_SetFloatArray(upy,Vupy);
  F77_SetInt(itpat,Vitpat);
  sgtnzu_(&n,upx,upy,&itpat);
  return Qnil;
}

static VALUE
dcl_sgtnzv(self,Vn,Vvpx,Vvpy,Vitpat)
    VALUE self,Vn,Vvpx,Vvpy,Vitpat;
{
  F77_SetInt(n,Vn);
  F77_SetFloatArray(vpx,Vvpx);
  F77_SetFloatArray(vpy,Vvpy);
  F77_SetInt(itpat,Vitpat);
  sgtnzv_(&n,vpx,vpy,&itpat);
  return Qnil;
}

static VALUE
dcl_sgtrqf(self,Vntx,Vltr)
    VALUE self,Vntx,Vltr;
{
  F77_SetInt(ntx,Vntx);
  int    ltr;
  sgtrqf_(&ntx,&ltr);
  F77_GetLogic(ltr,Vltr);
  return Qnil;
}

static VALUE
dcl_sgtrsl(self,Vcts,Vctl)
    VALUE self,Vcts,Vctl;
{
  F77_SetString(cts,Vcts);
  char * ctl="                ";
  sgtrsl_(cts,ctl,strlen(cts),strlen(ctl));
  F77_GetString(ctl,Vctl);
  return Qnil;
}

static VALUE
dcl_sgtrsn(self,Vcts,Vntx)
    VALUE self,Vcts,Vntx;
{
  F77_SetString(cts,Vcts);
  int   ntx;
  sgtrsn_(cts,&ntx,strlen(cts));
  F77_GetInt(ntx,Vntx);
  return Qnil;
}

static VALUE
dcl_sgtrls(self,Vctl,Vcts)
    VALUE self,Vctl,Vcts;
{
  F77_SetString(ctl,Vctl);
  char * cts="                ";
  sgtrls_(ctl,cts,strlen(ctl),strlen(cts));
  F77_GetString(cts,Vcts);
  return Qnil;
}

static VALUE
dcl_sgtrln(self,Vctl,Vntx)
    VALUE self,Vctl,Vntx;
{
  F77_SetString(ctl,Vctl);
  int   ntx;
  sgtrln_(ctl,&ntx,strlen(ctl));
  F77_GetInt(ntx,Vntx);
  return Qnil;
}

static VALUE
dcl_sgtrns(self,Vntx,Vcts)
    VALUE self,Vntx,Vcts;
{
  F77_SetInt(ntx,Vntx);
  char * cts="                ";
  sgtrns_(&ntx,cts,strlen(cts));
  F77_GetString(cts,Vcts);
  return Qnil;
}

static VALUE
dcl_sgtrnl(self,Vntx,Vctl)
    VALUE self,Vntx,Vctl;
{
  F77_SetInt(ntx,Vntx);
  char * ctl="                ";
  sgtrnl_(&ntx,ctl,strlen(ctl));
  F77_GetString(ctl,Vctl);
  return Qnil;
}

static VALUE
dcl_sgtxu(self,Vux,Vuy,Vchars)
    VALUE self,Vux,Vuy,Vchars;
{
  F77_SetFloat(ux,Vux);
  F77_SetFloat(uy,Vuy);
  F77_SetString(chars,Vchars);
  sgtxu_(&ux,&uy,chars,strlen(chars));
  return Qnil;
}

static VALUE
dcl_sgtxv(self,Vvx,Vvy,Vchars)
    VALUE self,Vvx,Vvy,Vchars;
{
  F77_SetFloat(vx,Vvx);
  F77_SetFloat(vy,Vvy);
  F77_SetString(chars,Vchars);
  sgtxv_(&vx,&vy,chars,strlen(chars));
  return Qnil;
}

static VALUE
dcl_sgtxr(self,Vrx,Vry,Vchars)
    VALUE self,Vrx,Vry,Vchars;
{
  F77_SetFloat(rx,Vrx);
  F77_SetFloat(ry,Vry);
  F77_SetString(chars,Vchars);
  sgtxr_(&rx,&ry,chars,strlen(chars));
  return Qnil;
}

static VALUE
dcl_sgstxs(self,Vrsize)
    VALUE self,Vrsize;
{
  F77_SetFloat(rsize,Vrsize);
  sgstxs_(&rsize);
  return Qnil;
}

static VALUE
dcl_sgqtxs(self,Vrsize)
    VALUE self,Vrsize;
{
  float rsize;
  sgqtxs_(&rsize);
  F77_GetFloat(rsize,Vrsize);
  return Qnil;
}

static VALUE
dcl_sgstxr(self,Virota)
    VALUE self,Virota;
{
  F77_SetInt(irota,Virota);
  sgstxr_(&irota);
  return Qnil;
}

static VALUE
dcl_sgqtxr(self,Virota)
    VALUE self,Virota;
{
  int   irota;
  sgqtxr_(&irota);
  F77_GetInt(irota,Virota);
  return Qnil;
}

static VALUE
dcl_sgstxc(self,Vicent)
    VALUE self,Vicent;
{
  F77_SetInt(icent,Vicent);
  sgstxc_(&icent);
  return Qnil;
}

static VALUE
dcl_sgqtxc(self,Vicent)
    VALUE self,Vicent;
{
  int   icent;
  sgqtxc_(&icent);
  F77_GetInt(icent,Vicent);
  return Qnil;
}

static VALUE
dcl_sgstxi(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  sgstxi_(&index);
  return Qnil;
}

static VALUE
dcl_sgqtxi(self,Vindex)
    VALUE self,Vindex;
{
  int   index;
  sgqtxi_(&index);
  F77_GetInt(index,Vindex);
  return Qnil;
}

static VALUE
dcl_sgtxzr(self,Vrx,Vry,Vchars,Vrsize,Virota,Vicent,Vindex)
    VALUE self,Vrx,Vry,Vchars,Vrsize,Virota,Vicent,Vindex;
{
  F77_SetFloat(rx,Vrx);
  F77_SetFloat(ry,Vry);
  F77_SetString(chars,Vchars);
  F77_SetFloat(rsize,Vrsize);
  F77_SetInt(irota,Virota);
  F77_SetInt(icent,Vicent);
  F77_SetInt(index,Vindex);
  sgtxzr_(&rx,&ry,chars,&rsize,&irota,&icent,&index,strlen(chars));
  return Qnil;
}

static VALUE
dcl_sgtxzu(self,Vux,Vuy,Vchars,Vrsize,Virota,Vicent,Vindex)
    VALUE self,Vux,Vuy,Vchars,Vrsize,Virota,Vicent,Vindex;
{
  F77_SetFloat(ux,Vux);
  F77_SetFloat(uy,Vuy);
  F77_SetString(chars,Vchars);
  F77_SetFloat(rsize,Vrsize);
  F77_SetInt(irota,Virota);
  F77_SetInt(icent,Vicent);
  F77_SetInt(index,Vindex);
  sgtxzu_(&ux,&uy,chars,&rsize,&irota,&icent,&index,strlen(chars));
  return Qnil;
}

static VALUE
dcl_sgtxzv(self,Vvx,Vvy,Vchars,Vrsize,Virota,Vicent,Vindex)
    VALUE self,Vvx,Vvy,Vchars,Vrsize,Virota,Vicent,Vindex;
{
  F77_SetFloat(vx,Vvx);
  F77_SetFloat(vy,Vvy);
  F77_SetString(chars,Vchars);
  F77_SetFloat(rsize,Vrsize);
  F77_SetInt(irota,Virota);
  F77_SetInt(icent,Vicent);
  F77_SetInt(index,Vindex);
  sgtxzv_(&vx,&vy,chars,&rsize,&irota,&icent,&index,strlen(chars));
  return Qnil;
}

static VALUE
dcl_sldiv(self,Vcform,Vix,Viy)
    VALUE self,Vcform,Vix,Viy;
{
  F77_SetString(cform,Vcform);
  F77_SetInt(ix,Vix);
  F77_SetInt(iy,Viy);
  sldiv_(cform,&ix,&iy,strlen(cform));
  return Qnil;
}

static VALUE
dcl_sldivz(self)
    VALUE self;
{
  sldivz_();
  return Qnil;
}

static VALUE
dcl_slinit(self,Vwxmax,Vwymax,Vfact)
    VALUE self,Vwxmax,Vwymax,Vfact;
{
  F77_SetFloat(wxmax,Vwxmax);
  F77_SetFloat(wymax,Vwymax);
  F77_SetFloat(fact,Vfact);
  slinit_(&wxmax,&wymax,&fact);
  return Qnil;
}

static VALUE
dcl_slsize(self,Vcszez)
    VALUE self,Vcszez;
{
  F77_SetString(cszez,Vcszez);
  slsize_(cszez,strlen(cszez));
  return Qnil;
}

static VALUE
dcl_slform(self,Vdxa,Vdya)
    VALUE self,Vdxa,Vdya;
{
  F77_SetFloat(dxa,Vdxa);
  F77_SetFloat(dya,Vdya);
  slform_(&dxa,&dya);
  return Qnil;
}

static VALUE
dcl_slmgn(self,Vxl,Vxr,Vyb,Vyt)
    VALUE self,Vxl,Vxr,Vyb,Vyt;
{
  F77_SetFloat(xl,Vxl);
  F77_SetFloat(xr,Vxr);
  F77_SetFloat(yb,Vyb);
  F77_SetFloat(yt,Vyt);
  slmgn_(&xl,&xr,&yb,&yt);
  return Qnil;
}

static VALUE
dcl_slmgnz(self,Vxamin,Vxamax,Vyamin,Vyamax,Vxl,Vxr,Vyb,Vyt)
    VALUE self,Vxamin,Vxamax,Vyamin,Vyamax,Vxl,Vxr,Vyb,Vyt;
{
  float xamin;
  float xamax;
  float yamin;
  F77_SetFloat(yamax,Vyamax);
  F77_SetFloat(xl,Vxl);
  F77_SetFloat(xr,Vxr);
  F77_SetFloat(yb,Vyb);
  F77_SetFloat(yt,Vyt);
  slmgnz_(&xamin,&xamax,&yamin,&yamax,&xl,&xr,&yb,&yt);
  F77_GetFloat(xamin,Vxamin);
  F77_GetFloat(xamax,Vxamax);
  F77_GetFloat(yamin,Vyamin);
  return Qnil;
}

static VALUE
dcl_slpage(self,Vlev,Vifrm,Vipage)
    VALUE self,Vlev,Vifrm,Vipage;
{
  F77_SetInt(lev,Vlev);
  F77_SetInt(ifrm,Vifrm);
  int   ipage;
  slpage_(&lev,&ifrm,&ipage);
  F77_GetInt(ipage,Vipage);
  return Qnil;
}

static VALUE
dcl_slpcnr(self)
    VALUE self;
{
  slpcnr_();
  return Qnil;
}

static VALUE
dcl_slpvpc(self,Vindex,Vrc)
    VALUE self,Vindex,Vrc;
{
  F77_SetInt(index,Vindex);
  F77_SetFloat(rc,Vrc);
  slpvpc_(&index,&rc);
  return Qnil;
}

static VALUE
dcl_slpvpr(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  slpvpr_(&index);
  return Qnil;
}

static VALUE
dcl_slpwvc(self,Vindex,Vrc)
    VALUE self,Vindex,Vrc;
{
  F77_SetInt(index,Vindex);
  F77_SetFloat(rc,Vrc);
  slpwvc_(&index,&rc);
  return Qnil;
}

static VALUE
dcl_slpwvr(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  slpwvr_(&index);
  return Qnil;
}

static VALUE
dcl_slpwwc(self,Vindex,Vrc)
    VALUE self,Vindex,Vrc;
{
  F77_SetInt(index,Vindex);
  F77_SetFloat(rc,Vrc);
  slpwwc_(&index,&rc);
  return Qnil;
}

static VALUE
dcl_slpwwr(self,Vindex)
    VALUE self,Vindex;
{
  F77_SetInt(index,Vindex);
  slpwwr_(&index);
  return Qnil;
}

static VALUE
dcl_slqrct(self,Vlev,Vifrm,Vxamin,Vxamax,Vyamin,Vyamax)
    VALUE self,Vlev,Vifrm,Vxamin,Vxamax,Vyamin,Vyamax;
{
  F77_SetInt(lev,Vlev);
  F77_SetInt(ifrm,Vifrm);
  float xamin;
  float xamax;
  float yamin;
  F77_SetFloat(yamax,Vyamax);
  slqrct_(&lev,&ifrm,&xamin,&xamax,&yamin,&yamax);
  F77_GetFloat(xamin,Vxamin);
  F77_GetFloat(xamax,Vxamax);
  F77_GetFloat(yamin,Vyamin);
  return Qnil;
}

static VALUE
dcl_slqsiz(self,Vcsize,Vdx,Vdy)
    VALUE self,Vcsize,Vdx,Vdy;
{
  F77_SetString(csize,Vcsize);
  float dx;
  float dy;
  slqsiz_(csize,&dx,&dy,strlen(csize));
  F77_GetFloat(dx,Vdx);
  F77_GetFloat(dy,Vdy);
  return Qnil;
}

static VALUE
dcl_slrat(self,Vrx,Vry)
    VALUE self,Vrx,Vry;
{
  F77_SetFloat(rx,Vrx);
  F77_SetFloat(ry,Vry);
  slrat_(&rx,&ry);
  return Qnil;
}

static VALUE
dcl_slratz(self,Vxamin,Vxamax,Vyamin,Vyamax,Vrx,Vry)
    VALUE self,Vxamin,Vxamax,Vyamin,Vyamax,Vrx,Vry;
{
  F77_SetFloat(xamin,Vxamin);
  F77_SetFloat(xamax,Vxamax);
  F77_SetFloat(yamin,Vyamin);
  F77_SetFloat(yamax,Vyamax);
  F77_SetFloat(rx,Vrx);
  F77_SetFloat(ry,Vry);
  slratz_(&xamin,&xamax,&yamin,&yamax,&rx,&ry);
  return Qnil;
}

static VALUE
dcl_slsttl(self,Vcttl,Vcside,Vpx,Vpy,Vht,Vnt)
    VALUE self,Vcttl,Vcside,Vpx,Vpy,Vht,Vnt;
{
  F77_SetString(cttl,Vcttl);
  F77_SetString(cside,Vcside);
  F77_SetFloat(px,Vpx);
  F77_SetFloat(py,Vpy);
  F77_SetFloat(ht,Vht);
  F77_SetInt(nt,Vnt);
  slsttl_(cttl,cside,&px,&py,&ht,&nt,strlen(cttl),strlen(cside));
  return Qnil;
}

static VALUE
dcl_sldttl(self,Vnt)
    VALUE self,Vnt;
{
  F77_SetInt(nt,Vnt);
  sldttl_(&nt);
  return Qnil;
}

static VALUE
dcl_slpttl(self)
    VALUE self;
{
  slpttl_();
  return Qnil;
}

static VALUE
dcl_sltlcv(self,Vctlin,Vctlout,Vlout)
    VALUE self,Vctlin,Vctlout,Vlout;
{
  F77_SetString(ctlin,Vctlin);
  char * ctlout="                ";
  F77_SetInt(lout,Vlout);
  sltlcv_(ctlin,ctlout,&lout,strlen(ctlin),strlen(ctlout));
  F77_GetString(ctlout,Vctlout);
  return Qnil;
}

static VALUE
dcl_slzttl(self,Vcside,Vcttl,Vpx,Vpy,Vrsize,Vindex)
    VALUE self,Vcside,Vcttl,Vpx,Vpy,Vrsize,Vindex;
{
  F77_SetString(cside,Vcside);
  F77_SetString(cttl,Vcttl);
  F77_SetFloat(px,Vpx);
  F77_SetFloat(py,Vpy);
  F77_SetFloat(rsize,Vrsize);
  F77_SetInt(index,Vindex);
  slzttl_(cside,cttl,&px,&py,&rsize,&index,strlen(cside),strlen(cttl));
  return Qnil;
}

static VALUE
dcl_stfpr3(self,Vx,Vy,Vz,Vrx,Vry)
    VALUE self,Vx,Vy,Vz,Vrx,Vry;
{
  F77_SetFloat(x,Vx);
  F77_SetFloat(y,Vy);
  F77_SetFloat(z,Vz);
  float rx;
  float ry;
  stfpr3_(&x,&y,&z,&rx,&ry);
  F77_GetFloat(rx,Vrx);
  F77_GetFloat(ry,Vry);
  return Qnil;
}

static VALUE
dcl_stspr3(self)
    VALUE self;
{
  stspr3_();
  return Qnil;
}

static VALUE
dcl_stfpr2(self,Vx,Vy,Vrx,Vry)
    VALUE self,Vx,Vy,Vrx,Vry;
{
  F77_SetFloat(x,Vx);
  F77_SetFloat(y,Vy);
  float rx;
  float ry;
  stfpr2_(&x,&y,&rx,&ry);
  F77_GetFloat(rx,Vrx);
  F77_GetFloat(ry,Vry);
  return Qnil;
}

static VALUE
dcl_stipr2(self,Vrx,Vry,Vx,Vy)
    VALUE self,Vrx,Vry,Vx,Vy;
{
  F77_SetFloat(rx,Vrx);
  F77_SetFloat(ry,Vry);
  float x;
  float y;
  stipr2_(&rx,&ry,&x,&y);
  F77_GetFloat(x,Vx);
  F77_GetFloat(y,Vy);
  return Qnil;
}

static VALUE
dcl_stspr2(self,Vix,Viy,Vsect)
    VALUE self,Vix,Viy,Vsect;
{
  F77_SetInt(ix,Vix);
  F77_SetInt(iy,Viy);
  F77_SetFloat(sect,Vsect);
  stspr2_(&ix,&iy,&sect);
  return Qnil;
}

static VALUE
dcl_stepr2(self)
    VALUE self;
{
  stepr2_();
  return Qnil;
}

static VALUE
dcl_strpr2(self)
    VALUE self;
{
  strpr2_();
  return Qnil;
}

static VALUE
dcl_stfrad(self,Vx,Vy,Vrx,Vry)
    VALUE self,Vx,Vy,Vrx,Vry;
{
  F77_SetFloat(x,Vx);
  F77_SetFloat(y,Vy);
  float rx;
  float ry;
  stfrad_(&x,&y,&rx,&ry);
  F77_GetFloat(rx,Vrx);
  F77_GetFloat(ry,Vry);
  return Qnil;
}

static VALUE
dcl_stirad(self,Vrx,Vry,Vx,Vy)
    VALUE self,Vrx,Vry,Vx,Vy;
{
  F77_SetFloat(rx,Vrx);
  F77_SetFloat(ry,Vry);
  float x;
  float y;
  stirad_(&rx,&ry,&x,&y);
  F77_GetFloat(x,Vx);
  F77_GetFloat(y,Vy);
  return Qnil;
}

static VALUE
dcl_stsrad(self,Vlxdeg,Vlydeg)
    VALUE self,Vlxdeg,Vlydeg;
{
  F77_SetLogic(lxdeg,Vlxdeg);
  F77_SetLogic(lydeg,Vlydeg);
  stsrad_(&lxdeg,&lydeg);
  return Qnil;
}

static VALUE
dcl_stfrot(self,Vux,Vuy,Vtx,Vty)
    VALUE self,Vux,Vuy,Vtx,Vty;
{
  F77_SetFloat(ux,Vux);
  F77_SetFloat(uy,Vuy);
  F77_SetFloat(tx,Vtx);
  float ty;
  stfrot_(&ux,&uy,&tx,&ty);
  F77_GetFloat(ty,Vty);
  return Qnil;
}

static VALUE
dcl_stirot(self,Vtx,Vty,Vux,Vuy)
    VALUE self,Vtx,Vty,Vux,Vuy;
{
  F77_SetFloat(tx,Vtx);
  F77_SetFloat(ty,Vty);
  F77_SetFloat(ux,Vux);
  float uy;
  stirot_(&tx,&ty,&ux,&uy);
  F77_GetFloat(uy,Vuy);
  return Qnil;
}

static VALUE
dcl_stsrot(self,Vtheta,Vphi,Vpsi)
    VALUE self,Vtheta,Vphi,Vpsi;
{
  F77_SetFloat(theta,Vtheta);
  F77_SetFloat(phi,Vphi);
  F77_SetFloat(psi,Vpsi);
  stsrot_(&theta,&phi,&psi);
  return Qnil;
}

static VALUE
dcl_stftr3(self,Vux,Vuy,Vuz,Vvx,Vvy,Vvz)
    VALUE self,Vux,Vuy,Vuz,Vvx,Vvy,Vvz;
{
  F77_SetFloat(ux,Vux);
  F77_SetFloat(uy,Vuy);
  F77_SetFloat(uz,Vuz);
  float vx;
  float vy;
  float vz;
  stftr3_(&ux,&uy,&uz,&vx,&vy,&vz);
  F77_GetFloat(vx,Vvx);
  F77_GetFloat(vy,Vvy);
  F77_GetFloat(vz,Vvz);
  return Qnil;
}

static VALUE
dcl_ststr3(self,Vitr,Vcxa,Vcya,Vcza,Vvxoff,Vvyoff,Vvzoff)
    VALUE self,Vitr,Vcxa,Vcya,Vcza,Vvxoff,Vvyoff,Vvzoff;
{
  F77_SetInt(itr,Vitr);
  F77_SetFloat(cxa,Vcxa);
  F77_SetFloat(cya,Vcya);
  F77_SetFloat(cza,Vcza);
  F77_SetFloat(vxoff,Vvxoff);
  F77_SetFloat(vyoff,Vvyoff);
  F77_SetFloat(vzoff,Vvzoff);
  ststr3_(&itr,&cxa,&cya,&cza,&vxoff,&vyoff,&vzoff);
  return Qnil;
}

static VALUE
dcl_stsrd3(self,Vlxrd,Vlyrd,Vlzrd)
    VALUE self,Vlxrd,Vlyrd,Vlzrd;
{
  F77_SetLogic(lxrd,Vlxrd);
  F77_SetLogic(lyrd,Vlyrd);
  F77_SetLogic(lzrd,Vlzrd);
  stsrd3_(&lxrd,&lyrd,&lzrd);
  return Qnil;
}

static VALUE
dcl_stslg3(self,Vlxlg,Vlylg,Vlzlg)
    VALUE self,Vlxlg,Vlylg,Vlzlg;
{
  F77_SetLogic(lxlg,Vlxlg);
  F77_SetLogic(lylg,Vlylg);
  F77_SetLogic(lzlg,Vlzlg);
  stslg3_(&lxlg,&lylg,&lzlg);
  return Qnil;
}

static VALUE
dcl_stftrf(self,Vux,Vuy,Vvx,Vvy)
    VALUE self,Vux,Vuy,Vvx,Vvy;
{
  F77_SetFloat(ux,Vux);
  F77_SetFloat(uy,Vuy);
  float vx;
  float vy;
  stftrf_(&ux,&uy,&vx,&vy);
  F77_GetFloat(vx,Vvx);
  F77_GetFloat(vy,Vvy);
  return Qnil;
}

static VALUE
dcl_stitrf(self,Vvx,Vvy,Vux,Vuy)
    VALUE self,Vvx,Vvy,Vux,Vuy;
{
  F77_SetFloat(vx,Vvx);
  F77_SetFloat(vy,Vvy);
  float ux;
  float uy;
  stitrf_(&vx,&vy,&ux,&uy);
  F77_GetFloat(ux,Vux);
  F77_GetFloat(uy,Vuy);
  return Qnil;
}

static VALUE
dcl_stqtrf(self,Vlmapa)
    VALUE self,Vlmapa;
{
  int    lmapa;
  stqtrf_(&lmapa);
  F77_GetLogic(lmapa,Vlmapa);
  return Qnil;
}

static VALUE
dcl_ststrf(self,Vlmapa)
    VALUE self,Vlmapa;
{
  F77_SetLogic(lmapa,Vlmapa);
  ststrf_(&lmapa);
  return Qnil;
}

static VALUE
dcl_stftrn(self,Vux,Vuy,Vvx,Vvy)
    VALUE self,Vux,Vuy,Vvx,Vvy;
{
  F77_SetFloat(ux,Vux);
  F77_SetFloat(uy,Vuy);
  float vx;
  float vy;
  stftrn_(&ux,&uy,&vx,&vy);
  F77_GetFloat(vx,Vvx);
  F77_GetFloat(vy,Vvy);
  return Qnil;
}

static VALUE
dcl_stitrn(self,Vvx,Vvy,Vux,Vuy)
    VALUE self,Vvx,Vvy,Vux,Vuy;
{
  F77_SetFloat(vx,Vvx);
  F77_SetFloat(vy,Vvy);
  float ux;
  float uy;
  stitrn_(&vx,&vy,&ux,&uy);
  F77_GetFloat(ux,Vux);
  F77_GetFloat(uy,Vuy);
  return Qnil;
}

static VALUE
dcl_ststrn(self,Vitr,Vcxa,Vcya,Vvxoff,Vvyoff)
    VALUE self,Vitr,Vcxa,Vcya,Vvxoff,Vvyoff;
{
  F77_SetInt(itr,Vitr);
  F77_SetFloat(cxa,Vcxa);
  F77_SetFloat(cya,Vcya);
  F77_SetFloat(vxoff,Vvxoff);
  F77_SetFloat(vyoff,Vvyoff);
  ststrn_(&itr,&cxa,&cya,&vxoff,&vyoff);
  return Qnil;
}

static VALUE
dcl_stfusr(self,Vux,Vuy,Vxx,Vyy)
    VALUE self,Vux,Vuy,Vxx,Vyy;
{
  F77_SetFloat(ux,Vux);
  F77_SetFloat(uy,Vuy);
  float xx;
  float yy;
  stfusr_(&ux,&uy,&xx,&yy);
  F77_GetFloat(xx,Vxx);
  F77_GetFloat(yy,Vyy);
  return Qnil;
}

static VALUE
dcl_stiusr(self,Vxx,Vyy,Vux,Vuy)
    VALUE self,Vxx,Vyy,Vux,Vuy;
{
  F77_SetFloat(xx,Vxx);
  F77_SetFloat(yy,Vyy);
  float ux;
  float uy;
  stiusr_(&xx,&yy,&ux,&uy);
  F77_GetFloat(ux,Vux);
  F77_GetFloat(uy,Vuy);
  return Qnil;
}

static VALUE
dcl_stsusr(self)
    VALUE self;
{
  stsusr_();
  return Qnil;
}

static VALUE
dcl_stfwtr(self,Vrx,Vry,Vwx,Vwy)
    VALUE self,Vrx,Vry,Vwx,Vwy;
{
  F77_SetFloat(rx,Vrx);
  F77_SetFloat(ry,Vry);
  float wx;
  float wy;
  stfwtr_(&rx,&ry,&wx,&wy);
  F77_GetFloat(wx,Vwx);
  F77_GetFloat(wy,Vwy);
  return Qnil;
}

static VALUE
dcl_stiwtr(self,Vwx,Vwy,Vrx,Vry)
    VALUE self,Vwx,Vwy,Vrx,Vry;
{
  F77_SetFloat(wx,Vwx);
  F77_SetFloat(wy,Vwy);
  float rx;
  float ry;
  stiwtr_(&wx,&wy,&rx,&ry);
  F77_GetFloat(rx,Vrx);
  F77_GetFloat(ry,Vry);
  return Qnil;
}

static VALUE
dcl_stswtr(self)
    VALUE self;
{
  stswtr_();
  return Qnil;
}

static VALUE
dcl_stqwtr(self)
    VALUE self;
{
  stqwtr_();
  return Qnil;
}

static VALUE
dcl_stswrc(self,Vwsxmn,Vwsxmx,Vwsymn,Vwsymx)
    VALUE self,Vwsxmn,Vwsxmx,Vwsymn,Vwsymx;
{
  F77_SetFloat(wsxmn,Vwsxmn);
  F77_SetFloat(wsxmx,Vwsxmx);
  F77_SetFloat(wsymn,Vwsymn);
  F77_SetFloat(wsymx,Vwsymx);
  stswrc_(&wsxmn,&wsxmx,&wsymn,&wsymx);
  return Qnil;
}

static VALUE
dcl_stqwrc(self,Vwsxmn,Vwsxmx,Vwsymn,Vwsymx)
    VALUE self,Vwsxmn,Vwsxmx,Vwsymn,Vwsymx;
{
  float wsxmn;
  float wsxmx;
  float wsymn;
  float wsymx;
  stqwrc_(&wsxmn,&wsxmx,&wsymn,&wsymx);
  F77_GetFloat(wsxmn,Vwsxmn);
  F77_GetFloat(wsxmx,Vwsxmx);
  F77_GetFloat(wsymn,Vwsymn);
  F77_GetFloat(wsymx,Vwsymx);
  return Qnil;
}

Init_mcdcl()
{
   VALUE mDcl = rb_define_module("Dcl");

   rb_define_module_function(mDcl, "csgi", dcl_csgi, 1);
   rb_define_module_function(mDcl, "isgc", dcl_isgc, 1);
   rb_define_module_function(mDcl, "scplu", dcl_scplu, 4);
   rb_define_module_function(mDcl, "scplv", dcl_scplv, 4);
   rb_define_module_function(mDcl, "scspli", dcl_scspli, 1);
   rb_define_module_function(mDcl, "scqpli", dcl_scqpli, 1);
   rb_define_module_function(mDcl, "scplzu", dcl_scplzu, 5);
   rb_define_module_function(mDcl, "scplzv", dcl_scplzv, 5);
   rb_define_module_function(mDcl, "scpmu", dcl_scpmu, 4);
   rb_define_module_function(mDcl, "scpmv", dcl_scpmv, 4);
   rb_define_module_function(mDcl, "scspmt", dcl_scspmt, 1);
   rb_define_module_function(mDcl, "scqpmt", dcl_scqpmt, 1);
   rb_define_module_function(mDcl, "scspmi", dcl_scspmi, 1);
   rb_define_module_function(mDcl, "scqpmi", dcl_scqpmi, 1);
   rb_define_module_function(mDcl, "scspms", dcl_scspms, 1);
   rb_define_module_function(mDcl, "scqpms", dcl_scqpms, 1);
   rb_define_module_function(mDcl, "scpmzu", dcl_scpmzu, 7);
   rb_define_module_function(mDcl, "scpmzv", dcl_scpmzv, 7);
   rb_define_module_function(mDcl, "scseye", dcl_scseye, 3);
   rb_define_module_function(mDcl, "scqeye", dcl_scqeye, 3);
   rb_define_module_function(mDcl, "scslog", dcl_scslog, 3);
   rb_define_module_function(mDcl, "scqlog", dcl_scqlog, 3);
   rb_define_module_function(mDcl, "scsobj", dcl_scsobj, 3);
   rb_define_module_function(mDcl, "scqobj", dcl_scqobj, 3);
   rb_define_module_function(mDcl, "scsorg", dcl_scsorg, 4);
   rb_define_module_function(mDcl, "scqorg", dcl_scqorg, 4);
   rb_define_module_function(mDcl, "scspln", dcl_scspln, 3);
   rb_define_module_function(mDcl, "scqpln", dcl_scqpln, 3);
   rb_define_module_function(mDcl, "scsprj", dcl_scsprj, 0);
   rb_define_module_function(mDcl, "scstrf", dcl_scstrf, 0);
   rb_define_module_function(mDcl, "scstrn", dcl_scstrn, 1);
   rb_define_module_function(mDcl, "scqtrn", dcl_scqtrn, 1);
   rb_define_module_function(mDcl, "scsvpt", dcl_scsvpt, 6);
   rb_define_module_function(mDcl, "scqvpt", dcl_scqvpt, 6);
   rb_define_module_function(mDcl, "scswnd", dcl_scswnd, 6);
   rb_define_module_function(mDcl, "scqwnd", dcl_scqwnd, 6);
   rb_define_module_function(mDcl, "sctnu", dcl_sctnu, 3);
   rb_define_module_function(mDcl, "sctnv", dcl_sctnv, 3);
   rb_define_module_function(mDcl, "scstnp", dcl_scstnp, 2);
   rb_define_module_function(mDcl, "scqtnp", dcl_scqtnp, 2);
   rb_define_module_function(mDcl, "sctnzu", dcl_sctnzu, 5);
   rb_define_module_function(mDcl, "sctnzv", dcl_sctnzv, 5);
   rb_define_module_function(mDcl, "isgtrc", dcl_isgtrc, 1);
   rb_define_module_function(mDcl, "sglau", dcl_sglau, 4);
   rb_define_module_function(mDcl, "sglav", dcl_sglav, 4);
   rb_define_module_function(mDcl, "sglar", dcl_sglar, 4);
   rb_define_module_function(mDcl, "sgslat", dcl_sgslat, 1);
   rb_define_module_function(mDcl, "sgqlat", dcl_sgqlat, 1);
   rb_define_module_function(mDcl, "sgslai", dcl_sgslai, 1);
   rb_define_module_function(mDcl, "sgqlai", dcl_sgqlai, 1);
   rb_define_module_function(mDcl, "sglazr", dcl_sglazr, 6);
   rb_define_module_function(mDcl, "sglazu", dcl_sglazu, 6);
   rb_define_module_function(mDcl, "sglazv", dcl_sglazv, 6);
   rb_define_module_function(mDcl, "sglnu", dcl_sglnu, 4);
   rb_define_module_function(mDcl, "sglnv", dcl_sglnv, 4);
   rb_define_module_function(mDcl, "sglnr", dcl_sglnr, 4);
   rb_define_module_function(mDcl, "sgslni", dcl_sgslni, 1);
   rb_define_module_function(mDcl, "sgqlni", dcl_sgqlni, 1);
   rb_define_module_function(mDcl, "sglnzr", dcl_sglnzr, 5);
   rb_define_module_function(mDcl, "sglnzu", dcl_sglnzu, 5);
   rb_define_module_function(mDcl, "sglnzv", dcl_sglnzv, 5);
   rb_define_module_function(mDcl, "sgopn", dcl_sgopn, 1);
   rb_define_module_function(mDcl, "sginit", dcl_sginit, 0);
   rb_define_module_function(mDcl, "sgfrm", dcl_sgfrm, 0);
   rb_define_module_function(mDcl, "sgcls", dcl_sgcls, 0);
   rb_define_module_function(mDcl, "sgpget", dcl_sgpget, 2);
   rb_define_module_function(mDcl, "sgiget", dcl_sgiget, 2);
   rb_define_module_function(mDcl, "sgrget", dcl_sgrget, 2);
   rb_define_module_function(mDcl, "sglget", dcl_sglget, 2);
   rb_define_module_function(mDcl, "sgpset", dcl_sgpset, 2);
   rb_define_module_function(mDcl, "sgiset", dcl_sgiset, 2);
   rb_define_module_function(mDcl, "sgrset", dcl_sgrset, 2);
   rb_define_module_function(mDcl, "sglset", dcl_sglset, 2);
   rb_define_module_function(mDcl, "sgpstx", dcl_sgpstx, 2);
   rb_define_module_function(mDcl, "sgistx", dcl_sgistx, 2);
   rb_define_module_function(mDcl, "sgrstx", dcl_sgrstx, 2);
   rb_define_module_function(mDcl, "sglstx", dcl_sglstx, 2);
   rb_define_module_function(mDcl, "sgplu", dcl_sgplu, 3);
   rb_define_module_function(mDcl, "sgplv", dcl_sgplv, 3);
   rb_define_module_function(mDcl, "sgplr", dcl_sgplr, 3);
   rb_define_module_function(mDcl, "sgsplt", dcl_sgsplt, 1);
   rb_define_module_function(mDcl, "sgqplt", dcl_sgqplt, 1);
   rb_define_module_function(mDcl, "sgspli", dcl_sgspli, 1);
   rb_define_module_function(mDcl, "sgqpli", dcl_sgqpli, 1);
   rb_define_module_function(mDcl, "sgplzr", dcl_sgplzr, 5);
   rb_define_module_function(mDcl, "sgplzu", dcl_sgplzu, 5);
   rb_define_module_function(mDcl, "sgplzv", dcl_sgplzv, 5);
   rb_define_module_function(mDcl, "sgpmu", dcl_sgpmu, 3);
   rb_define_module_function(mDcl, "sgpmv", dcl_sgpmv, 3);
   rb_define_module_function(mDcl, "sgpmr", dcl_sgpmr, 3);
   rb_define_module_function(mDcl, "sgspmt", dcl_sgspmt, 1);
   rb_define_module_function(mDcl, "sgqpmt", dcl_sgqpmt, 1);
   rb_define_module_function(mDcl, "sgspmi", dcl_sgspmi, 1);
   rb_define_module_function(mDcl, "sgqpmi", dcl_sgqpmi, 1);
   rb_define_module_function(mDcl, "sgspms", dcl_sgspms, 1);
   rb_define_module_function(mDcl, "sgqpms", dcl_sgqpms, 1);
   rb_define_module_function(mDcl, "sgpmzr", dcl_sgpmzr, 6);
   rb_define_module_function(mDcl, "sgpmzu", dcl_sgpmzu, 6);
   rb_define_module_function(mDcl, "sgpmzv", dcl_sgpmzv, 6);
   rb_define_module_function(mDcl, "sgpqnp", dcl_sgpqnp, 1);
   rb_define_module_function(mDcl, "sgpqid", dcl_sgpqid, 2);
   rb_define_module_function(mDcl, "sgpqcp", dcl_sgpqcp, 2);
   rb_define_module_function(mDcl, "sgpqvl", dcl_sgpqvl, 2);
   rb_define_module_function(mDcl, "sgpsvl", dcl_sgpsvl, 2);
   rb_define_module_function(mDcl, "sgpwsn", dcl_sgpwsn, 0);
   rb_define_module_function(mDcl, "sgsmpl", dcl_sgsmpl, 3);
   rb_define_module_function(mDcl, "sgqmpl", dcl_sgqmpl, 3);
   rb_define_module_function(mDcl, "sgsplc", dcl_sgsplc, 1);
   rb_define_module_function(mDcl, "sgqplc", dcl_sgqplc, 1);
   rb_define_module_function(mDcl, "sgspls", dcl_sgspls, 1);
   rb_define_module_function(mDcl, "sgqpls", dcl_sgqpls, 1);
   rb_define_module_function(mDcl, "sgnplc", dcl_sgnplc, 0);
   rb_define_module_function(mDcl, "sgssim", dcl_sgssim, 3);
   rb_define_module_function(mDcl, "sgqsim", dcl_sgqsim, 3);
   rb_define_module_function(mDcl, "sgstrf", dcl_sgstrf, 0);
   rb_define_module_function(mDcl, "sgstrn", dcl_sgstrn, 1);
   rb_define_module_function(mDcl, "sgqtrn", dcl_sgqtrn, 1);
   rb_define_module_function(mDcl, "sgstxy", dcl_sgstxy, 4);
   rb_define_module_function(mDcl, "sgqtxy", dcl_sgqtxy, 4);
   rb_define_module_function(mDcl, "sgsvpt", dcl_sgsvpt, 4);
   rb_define_module_function(mDcl, "sgqvpt", dcl_sgqvpt, 4);
   rb_define_module_function(mDcl, "sgswnd", dcl_sgswnd, 4);
   rb_define_module_function(mDcl, "sgqwnd", dcl_sgqwnd, 4);
   rb_define_module_function(mDcl, "sgtnu", dcl_sgtnu, 3);
   rb_define_module_function(mDcl, "sgtnv", dcl_sgtnv, 3);
   rb_define_module_function(mDcl, "sgtnr", dcl_sgtnr, 3);
   rb_define_module_function(mDcl, "sgstnp", dcl_sgstnp, 1);
   rb_define_module_function(mDcl, "sgqtnp", dcl_sgqtnp, 1);
   rb_define_module_function(mDcl, "sgtnzr", dcl_sgtnzr, 4);
   rb_define_module_function(mDcl, "sgtnzu", dcl_sgtnzu, 4);
   rb_define_module_function(mDcl, "sgtnzv", dcl_sgtnzv, 4);
   rb_define_module_function(mDcl, "sgtrqf", dcl_sgtrqf, 2);
   rb_define_module_function(mDcl, "sgtrsl", dcl_sgtrsl, 2);
   rb_define_module_function(mDcl, "sgtrsn", dcl_sgtrsn, 2);
   rb_define_module_function(mDcl, "sgtrls", dcl_sgtrls, 2);
   rb_define_module_function(mDcl, "sgtrln", dcl_sgtrln, 2);
   rb_define_module_function(mDcl, "sgtrns", dcl_sgtrns, 2);
   rb_define_module_function(mDcl, "sgtrnl", dcl_sgtrnl, 2);
   rb_define_module_function(mDcl, "sgtxu", dcl_sgtxu, 3);
   rb_define_module_function(mDcl, "sgtxv", dcl_sgtxv, 3);
   rb_define_module_function(mDcl, "sgtxr", dcl_sgtxr, 3);
   rb_define_module_function(mDcl, "sgstxs", dcl_sgstxs, 1);
   rb_define_module_function(mDcl, "sgqtxs", dcl_sgqtxs, 1);
   rb_define_module_function(mDcl, "sgstxr", dcl_sgstxr, 1);
   rb_define_module_function(mDcl, "sgqtxr", dcl_sgqtxr, 1);
   rb_define_module_function(mDcl, "sgstxc", dcl_sgstxc, 1);
   rb_define_module_function(mDcl, "sgqtxc", dcl_sgqtxc, 1);
   rb_define_module_function(mDcl, "sgstxi", dcl_sgstxi, 1);
   rb_define_module_function(mDcl, "sgqtxi", dcl_sgqtxi, 1);
   rb_define_module_function(mDcl, "sgtxzr", dcl_sgtxzr, 7);
   rb_define_module_function(mDcl, "sgtxzu", dcl_sgtxzu, 7);
   rb_define_module_function(mDcl, "sgtxzv", dcl_sgtxzv, 7);
   rb_define_module_function(mDcl, "sldiv", dcl_sldiv, 3);
   rb_define_module_function(mDcl, "sldivz", dcl_sldivz, 0);
   rb_define_module_function(mDcl, "slinit", dcl_slinit, 3);
   rb_define_module_function(mDcl, "slsize", dcl_slsize, 1);
   rb_define_module_function(mDcl, "slform", dcl_slform, 2);
   rb_define_module_function(mDcl, "slmgn", dcl_slmgn, 4);
   rb_define_module_function(mDcl, "slmgnz", dcl_slmgnz, 8);
   rb_define_module_function(mDcl, "slpage", dcl_slpage, 3);
   rb_define_module_function(mDcl, "slpcnr", dcl_slpcnr, 0);
   rb_define_module_function(mDcl, "slpvpc", dcl_slpvpc, 2);
   rb_define_module_function(mDcl, "slpvpr", dcl_slpvpr, 1);
   rb_define_module_function(mDcl, "slpwvc", dcl_slpwvc, 2);
   rb_define_module_function(mDcl, "slpwvr", dcl_slpwvr, 1);
   rb_define_module_function(mDcl, "slpwwc", dcl_slpwwc, 2);
   rb_define_module_function(mDcl, "slpwwr", dcl_slpwwr, 1);
   rb_define_module_function(mDcl, "slqrct", dcl_slqrct, 6);
   rb_define_module_function(mDcl, "slqsiz", dcl_slqsiz, 3);
   rb_define_module_function(mDcl, "slrat", dcl_slrat, 2);
   rb_define_module_function(mDcl, "slratz", dcl_slratz, 6);
   rb_define_module_function(mDcl, "slsttl", dcl_slsttl, 6);
   rb_define_module_function(mDcl, "sldttl", dcl_sldttl, 1);
   rb_define_module_function(mDcl, "slpttl", dcl_slpttl, 0);
   rb_define_module_function(mDcl, "sltlcv", dcl_sltlcv, 3);
   rb_define_module_function(mDcl, "slzttl", dcl_slzttl, 6);
   rb_define_module_function(mDcl, "stfpr3", dcl_stfpr3, 5);
   rb_define_module_function(mDcl, "stspr3", dcl_stspr3, 0);
   rb_define_module_function(mDcl, "stfpr2", dcl_stfpr2, 4);
   rb_define_module_function(mDcl, "stipr2", dcl_stipr2, 4);
   rb_define_module_function(mDcl, "stspr2", dcl_stspr2, 3);
   rb_define_module_function(mDcl, "stepr2", dcl_stepr2, 0);
   rb_define_module_function(mDcl, "strpr2", dcl_strpr2, 0);
   rb_define_module_function(mDcl, "stfrad", dcl_stfrad, 4);
   rb_define_module_function(mDcl, "stirad", dcl_stirad, 4);
   rb_define_module_function(mDcl, "stsrad", dcl_stsrad, 2);
   rb_define_module_function(mDcl, "stfrot", dcl_stfrot, 4);
   rb_define_module_function(mDcl, "stirot", dcl_stirot, 4);
   rb_define_module_function(mDcl, "stsrot", dcl_stsrot, 3);
   rb_define_module_function(mDcl, "stftr3", dcl_stftr3, 6);
   rb_define_module_function(mDcl, "ststr3", dcl_ststr3, 7);
   rb_define_module_function(mDcl, "stsrd3", dcl_stsrd3, 3);
   rb_define_module_function(mDcl, "stslg3", dcl_stslg3, 3);
   rb_define_module_function(mDcl, "stftrf", dcl_stftrf, 4);
   rb_define_module_function(mDcl, "stitrf", dcl_stitrf, 4);
   rb_define_module_function(mDcl, "stqtrf", dcl_stqtrf, 1);
   rb_define_module_function(mDcl, "ststrf", dcl_ststrf, 1);
   rb_define_module_function(mDcl, "stftrn", dcl_stftrn, 4);
   rb_define_module_function(mDcl, "stitrn", dcl_stitrn, 4);
   rb_define_module_function(mDcl, "ststrn", dcl_ststrn, 5);
   rb_define_module_function(mDcl, "stfusr", dcl_stfusr, 4);
   rb_define_module_function(mDcl, "stiusr", dcl_stiusr, 4);
   rb_define_module_function(mDcl, "stsusr", dcl_stsusr, 0);
   rb_define_module_function(mDcl, "stfwtr", dcl_stfwtr, 4);
   rb_define_module_function(mDcl, "stiwtr", dcl_stiwtr, 4);
   rb_define_module_function(mDcl, "stswtr", dcl_stswtr, 0);
   rb_define_module_function(mDcl, "stqwtr", dcl_stqwtr, 0);
   rb_define_module_function(mDcl, "stswrc", dcl_stswrc, 4);
   rb_define_module_function(mDcl, "stqwrc", dcl_stqwrc, 4);
}

/* I don't know why this is neccessary */
MAIN__()
{
}
